function Move(name, command, tiles, immediate)
{
  switch (command)
  {
    case COMMAND_MOVE_NORTH:
      QueuePersonCommand(name, COMMAND_FACE_NORTH, immediate);
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_SOUTH:
      QueuePersonCommand(name, COMMAND_FACE_SOUTH, immediate);
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_EAST:
      QueuePersonCommand(name, COMMAND_FACE_EAST, immediate);
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_WEST:
      QueuePersonCommand(name, COMMAND_FACE_WEST, immediate);
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;
  }
}

function GenerateRandomMovement()
{
  var person = GetCurrentPerson();
  var commands = new Array(COMMAND_MOVE_NORTH, COMMAND_MOVE_EAST, COMMAND_MOVE_SOUTH, COMMAND_MOVE_WEST);
  var r1 = Math.floor(Math.random() * commands.length);
  var r2 = Math.floor(Math.random() * 3); // 3 being the number of tiles

  Move(person, commands[r1], r2, false);
}

function setimage(name, x, y, xsize, ysize){
	if(name) {
		var image = LoadImage(name);
		image.transformBlit(x, y, x + xsize, y, x + xsize, y +ysize, x, y +ysize);
	}
}

function sleep(millis)
 {
  var date = new Date();
  var curDate = null;
  do { curDate = new Date(); }
  while(curDate-date < millis);
}

function Character() {
	this.ID = '';

	this.Name = '';
	this.Level = '';
	this.MaxHP = 0;
	this.HP = 0;
	this.MaxMP = 0;
	this.MP = 0;
	
	this.Speed = 0;
	this.Strength = 0;
	this.Defense = 0;
	this.Mpower = 0;
	this.MDefense = 0;
	
	this.Exp = 0;
	this.Next = 0;
	this.Sprite = '';
	this.MenuImage = '';
	
	this.Resistance = Elements();
	
	return this;

}

function Elements() {
	this.Fire = 0;
	this.Water = 0;
	this.Ice = 0;
	this.Lightning = 0;
	this.Wind = 0;
	this.Earth = 0;
	this.Flora = 0;
	this.Light = 0;
	this.Shadow = 0;
	
	return this;
}


function Item() {
	this.ID = '';
	this.Name = '';
	
	this.Equipable = 0;
	this.UseBattle = 0;
	this.UseMenu = 0;
	
	this.EquipFunction = '';
	this.RemoveFunction = '';
	this.BattleFunction = '';
	this.MenuFunction = '';
	
	this.Description = '';
	this.Icon = '';
	
	this.Speed = 0;
	this.Strength = 0;
	this.Defense = 0;
	this.Mpower = 0;
	this.MDefense = 0;	
	
	this.Resistance = Elements();
	
	return this;
}



function addtoparty(ID) {
	if (party.length < 5) {
		party.push(ID);
		return 1;
	}
	else
		return 0;
}


// Traverse characters array and return character
function getcharacter(ID) {
	var c = Character();
	for(var i = 0; i < CHARACTER.length; i++)
		if(CHARACTER[i].ID == ID)
			c = CHARACTER[i];
	return c;
}



function giveitem(ID, count) {

	var maxitems = 8;
	var maxedout = 0;
	
	if(!count)
		count = 1;
	else if(count > maxitems)
		count = maxitems;
		
		
	// Walk through inventory, see if item exists and increment count or find first empty slot	
	var firstempty = -1;	
	for(var i = 0; i < inventory.length; i++) {
	
		if(inventory[i].ID == ID) {
			inventorycount[i] += count;
			if(inventorycount[i] > maxitems) {
				count = inventorycount[i] - maxitems;
				inventorycount[i] = maxitems;
				maxedout = 1;
			} else
				count = 0;
		} else if(!inventory[i].ID && (firstempty == -1))
			firstempty = i;
		
	}
	
	// If there are no empty slots, grow inventory size
	if(firstempty == -1) {
		firstempty = inventory.length;
		inventory.length++;
		inventorycount.length++;
	}
	
	
	// If did not offload items and not maxed out, add item to first empty slot
	if(!maxedout && (count > 0)){
		EvaluateScript('items/' + ID + '.js');
		inventory[firstempty] = new eval("Item_" + ID +"()");
		inventorycount[firstempty] = count;
		count = 0;
	}
	
	
	// return items not given
	return count;


}


// Old giveitem, allows unlimited items
function giveitem_orig(ID, count) {
	if(!count)
		count = 1;
	var maxitems = 99;
		
		
	// Walk through inventory, see if item exists and increment count or find first empty slot	
	var firstempty = -1;	
	for(var i = 0; i < inventory.length; i++) {
	
		if(inventory[i].ID == ID) {
			inventorycount[i] += count;
			if(inventorycount[i] > maxitems) {
				count = inventorycount[i] - maxitems;
				inventorycount[i] = maxitems;
			} else
				count = 0;
		} else if(!inventory[i].ID && (firstempty == -1))
			firstempty = i;
		
	}
	
	// If did not offload all items, add item to first empty slot
	if(count > 0) {
		EvaluateScript('items/' + ID + '.js');
		inventory[i] = new eval("Item_" + ID);
		inventorycount[i] = count;
	}

}



function NextLeader() {
	var slot = CURRENT_LEADER_SLOT;
	var loop = 1;
	while(loop) {
		slot++;
		if(slot > 4)
			slot = 0;
		if(party[slot])
			loop = 0;
		
	}
	var character = getcharacter(party[slot]);
	SetPersonSpriteset("Player", LoadSpriteset(character.Sprite));
	CURRENT_LEADER = party[slot];
	CURRENT_LEADER_SLOT = slot;
	
}
