//var font = LoadFont("term16.rfn");
var font = LoadFont("ms16.rfn");
var boldfont = LoadFont("ms16bold.rfn");
var window = LoadWindowStyle("DA3win2.rws");


function text(x, y, str) {
	var width = font.getStringWidth(str);
  var height = font.getStringHeight(str, width); 
	font.drawTextBox(x, y, width, height, 0, str);
}

function textbox(str, x, y) { 

	if(!x)
		x = 32;
	if(!y)
		y = 32;

  var width = font.getStringWidth(str);
  var height = font.getStringHeight(str, width); 
  window.drawWindow(x, y, width+32, height+16);
  font.drawTextBox(x+16, y+8, width, height, 0, str);

} 

function ClearKeyQueue() { 
  while (AreKeysLeft()) GetKey(); 
} 

function Wait() { 
  ClearKeyQueue();   
  var loop = 1;
  while(loop)
  {
		if(GetKey() == KEY_CONFIRM)
			loop = 0;
	} 
}

function mwin(position, imagefile, name, text) {
	var x = 32;
	var text_x;
	var y; 
	var print_width;
	
	var screen = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
	
	var width = GetScreenWidth() - 64;
  var height = 155;
	
	if(position == "top")
	{
		y = 32; 
		if(imagefile)
			text_x = 200; 
		else
			text_x = 48;
		print_width = width - text_x + 32;
	}
	else
	{
		y = GetScreenHeight() - height - 32;
		text_x = 48;
		if(imagefile)
			print_width = width - text_x + 32 - 140;
		else
			print_width = width - text_x + 32;
		
	}
	
		
  window.drawWindow(x, y, width, height);
  
  if(imagefile)
  {
		if(position == "top")
			setimage(imagefile, x+10, y+6, 140, 140);
		else
			setimage(imagefile, width - 118, y+6, 140, 140);
  }
  
  boldfont.drawTextBox(text_x, y, print_width, height, 10, name);
  font.drawTextBox(text_x, y+30, print_width, height, 10, text);
  
  FlipScreen();
  Wait(); 
  screen.transformBlit(0, 0, GetScreenWidth()-1, 0, GetScreenWidth()-1, GetScreenHeight()-1, 0, GetScreenHeight()-1);
  
}

function savescreen() {
	return  GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
}

function restorescreen(screen) {
	screen.transformBlit(0, 0, GetScreenWidth()-1, 0, GetScreenWidth()-1, GetScreenHeight()-1, 0, GetScreenHeight()-1);
}





function menu(x, y, choices, values) {
	var str = '';
	var width = 0;
	var ymove = 26;
	var maxchoice, i;
	
	for(i=0; i<choices.length; i++)
	{
		str += choices[i] + '\n';
		choicewidth = font.getStringWidth(choices[i]);
		if(choicewidth > width)
			width = choicewidth;
		
	}
	maxchoice = i-1;
	
	
  var height = font.getStringHeight(str, width+1); 
	window.drawWindow(x, y, width+54, height);
  font.drawTextBox(x+38, y+16, width, height, 0, str);
	
	var choice = 0;
	var loop = 1;
	var xloc = x + 15;
	var yloc;
	
	while(loop) {
		var screen = savescreen();
		yloc = y + 17 + (choice*ymove);
		setimage('cursor.png', xloc, yloc, 10, 19);
		FlipScreen();
		
		switch(GetKey()) {
			case KEY_UP:
				choice--;
				if(choice<0)
					choice = maxchoice;
				SFX_CURSOR.play();
				break;
			case KEY_DOWN:
				choice++;
				if(choice>maxchoice)
					choice = 0;
				SFX_CURSOR.play();
				break;
			case KEY_CONFIRM:
				loop = 0;
				SFX_SELECT.play();
				break;
			case KEY_BACK:
				loop = 0;
				choice = -1;
				SFX_BACK.play();
				break;
		}
		
		restorescreen(screen);
	}
	
	if(choice >= 0)
		return(values[choice]);
	else
		return -1;
}


function debug(text) {
	var screen = savescreen();
	textbox(text);
	FlipScreen();
	Wait();
	restorescreen(screen);
}


// items must be array of names
function selectmenu(x, y, width, yitems, items, counts, grayed, hoverfunctions) {
	var fontheight = 25;
	var show_desc = 0;
	

	var top = 0;
	var bottom = yitems;
	if(bottom > yitems-1)
		bottom = yitems-1;
		
	var choice = 0;
	var loop = 1;
	var yloc;
	var xloc = x + 16;
	var gray = CreateColor(128, 128, 128);
	var white = CreateColor(255, 255, 255);
	var linex = x+width-14
	var linetop = y+16;
	var linebottom = linetop + (yitems * fontheight);
	var linesize = linebottom - linetop;
	var barsize = Math.round((yitems/items.length) * linesize);
	var bary;
	

	window.drawWindow(x, y, width, (yitems * fontheight) + 32);
	Line(linex, linetop, linex, linebottom, gray);
	Line(linex+1, linetop, linex+1, linebottom, gray);
	
	screen2 = savescreen();
	
	
	while(loop)
	{
		restorescreen(screen2);
		for(i = 0; (i < yitems) && (i < items.length); i++) 
		{
			// Set to gray if grayed
			if(grayed[top+i])
				font.setColorMask(gray);
		
			// Draw item name
			if(items[top+i])
				font.drawTextBox(x+38, y+16 + (i*fontheight), width - 48, fontheight, 0, items[top+i]);
				
			// Draw item count
			if(counts[top+i])
				font.drawTextBox(x+width-60, y+16 + (i*fontheight), 50, fontheight, 0, counts[top+i]);
			
			if(grayed[top+i])
				font.setColorMask(white);
		
		}
		
		// Calculate bar position
		bary = ((top/items.length) * linesize) + linetop;
		Line(linex, bary, linex, bary+barsize, white);
		Line(linex+1, bary, linex+1, bary+barsize, white);
		
		// Hover function, if exists
		if(hoverfunctions[choice+top])
			eval(hoverfunctions[choice+top]);
		
		
		yloc = y + 17 + (choice*fontheight);
		setimage('cursor.png', xloc, yloc, 10, 19);
		FlipScreen();
		
		switch(GetKey()) {
			case KEY_UP:
				choice--;
				if(choice<0) {
					if(top <= 0) {
						choice = yitems-1;
						bottom = items.length;
						top = items.length - yitems;
					} else {
						top--;
						bottom--;
						choice = 0;
					}
				}
				SFX_CURSOR.play();
				break;
			case KEY_DOWN:
				choice++;
				if(choice>yitems-1) {
					if(bottom >= items.length-1) {
						choice = 0;
						bottom = yitems-1;
						top = 0;
					} else {
						top++;
						bottom++;
						choice = yitems-1;
					}
				}
				SFX_CURSOR.play();
				break;
			case KEY_CONFIRM:
				if(!grayed[choice+top] && items[choice+top]) {
					loop = 0;
					SFX_SELECT.play();
				}
				break;
			case KEY_BACK:
				loop = 0;
				choice = -1;
				SFX_BACK.play();
				break;
		}
		
	}
	
	if(choice < 0)
		return -1;
	else
		return choice + top;


	
}

